blob: 0576110e9c85081cb0bcdb821fe65faa357cad6f [file] [log] [blame]
Philipp Schrader773577f2021-12-17 23:45:39 -08001#!/bin/bash
2
3# Perform runfile initialization here so that child processes have a proper
4# RUNFILES_DIR variable set.
5
6# --- begin runfiles.bash initialization v2 ---
7# Copy-pasted from the Bazel Bash runfiles library v2.
8set -uo pipefail; f=bazel_tools/tools/bash/runfiles/runfiles.bash
9source "${RUNFILES_DIR:-/dev/null}/$f" 2>/dev/null || \
10 source "$(grep -sm1 "^$f " "${RUNFILES_MANIFEST_FILE:-/dev/null}" | cut -f2- -d' ')" 2>/dev/null || \
11 source "$0.runfiles/$f" 2>/dev/null || \
12 source "$(grep -sm1 "^$f " "$0.runfiles_manifest" | cut -f2- -d' ')" 2>/dev/null || \
13 source "$(grep -sm1 "^$f " "$0.exe.runfiles_manifest" | cut -f2- -d' ')" 2>/dev/null || \
14 { echo>&2 "ERROR: cannot find $f"; exit 1; }; f=; set -e
15# --- end runfiles.bash initialization v2 ---
16
Philipp Schrader37fdbb62021-12-18 00:30:37 -080017set -o nounset
18
19# Redirect the Go cache on buildkite. Otherwise we run into errors like:
20# "failed to initialize build cache at /var/lib/buildkite-agent/.cache/go-build"
21# due to permission errors.
22if ((RUNNING_IN_CI == 1)); then
23 export GOCACHE=/tmp/lint_go_cache
24fi
25
Philipp Schrader773577f2021-12-17 23:45:39 -080026gofmt() {
27 ./tools/lint/gofmt
28}
29
Philipp Schrader37fdbb62021-12-18 00:30:37 -080030gomod() {
31 local -r go="$(readlink -f external/go_sdk/bin/go)"
32 cd "${BUILD_WORKSPACE_DIRECTORY}"
33 "${go}" mod tidy -e
34}
35
36update_repos() {
Philipp Schraderd96d4cb2022-02-06 15:37:29 -080037 # Clear out the go_deps.bzl file so that gazelle won't hesitate to update
38 # it. Without this step gazelle would never try to remove a dependency.
39 cat > "${BUILD_WORKSPACE_DIRECTORY}"/go_deps.bzl <<EOF
40def go_dependencies():
41 pass
42EOF
Philipp Schrader37fdbb62021-12-18 00:30:37 -080043 ./gazelle-runner.bash update-repos \
44 -from_file=go.mod \
45 -to_macro=go_deps.bzl%go_dependencies \
46 -prune
47}
48
49gazelle() {
50 ./gazelle-runner.bash
51}
52
53tweak_gazelle_go_deps() {
54 local -r tweaker="$(readlink -f tools/go/tweak_gazelle_go_deps)"
55 cd "${BUILD_WORKSPACE_DIRECTORY}"
56 "${tweaker}" ./go_deps.bzl
57}
58
Philipp Schraderd96d4cb2022-02-06 15:37:29 -080059clean_up_go_mirrors() {
60 ./tools/go/mirror_go_repos --prune
61}
62
Philipp Schradercc016b32021-12-30 08:59:58 -080063buildifier() {
64 ./tools/lint/buildifier
65}
66
Philipp Schraderace08842022-03-26 14:52:55 -070067prettier() {
Philipp Schrader817cce32022-03-26 15:00:00 -070068 ./tools/lint/prettier
Philipp Schraderace08842022-03-26 14:52:55 -070069}
70
Philipp Schrader773577f2021-12-17 23:45:39 -080071git_status_is_clean() {
72 cd "${BUILD_WORKSPACE_DIRECTORY}"
73 if ! git diff --quiet; then
74 echo "One or more linters appear to have made changes to your code!" >&2
75 return 1
76 fi
77}
78
79# All the linters that we are going to run.
80readonly -a LINTERS=(
81 gofmt
Philipp Schrader37fdbb62021-12-18 00:30:37 -080082 gomod
83 update_repos
84 gazelle
85 tweak_gazelle_go_deps
Philipp Schraderd96d4cb2022-02-06 15:37:29 -080086 clean_up_go_mirrors
Philipp Schradercc016b32021-12-30 08:59:58 -080087 buildifier
Philipp Schraderace08842022-03-26 14:52:55 -070088 prettier
Philipp Schrader773577f2021-12-17 23:45:39 -080089 git_status_is_clean # This must the last linter.
90)
91
92failure=0
93for linter in "${LINTERS[@]}"; do
94 if ! (eval "${linter}"); then
95 failure=1
96 fi
97done
98
99if ((failure != 0)); then
100 echo "One or more linters failed." >&2
101 cd "${BUILD_WORKSPACE_DIRECTORY}"
102 git --no-pager diff || :
103 exit "${failure}"
104fi
105
106exit 0